- connection: ssh
  gather_facts: false
  hosts: 10.47.108.240
  remote_user: root
  vars:
    path: /root/cqaso-web/
    Thost: 10.47.108.240
    Tuser: root
    AppName: cqaso-web
    version: master
    port: 8000
  tasks:
    - name: 检测{{ path }}是否存在
      shell: ls -rtl "{{ path }}" || mkdir "{{ path }}"

#    - name: 备份老版本的项目文件
#      shell: tar -zcvf /tmp/release/{{ AppName }}-{{ version }}-old-`date +%Y%m%d%H%M%S` ./*
#      args:
#        chdir: "{{ path }}"
#      ignore_errors: yes

    - name: The tar decompressed
      shell: tar -xf {{ AppName }}-{{ version }}-new.tar.gz -C /root/{{ AppName }}
      args:
        chdir: /root
        
    - name: Install dependencies packages with yarn
      shell: yarn install --force && ls logs || mkdir logs
      register: yarn_out
      args:
        chdir: "{{ path }}"
       
    ##测试环境启动时候，不加--product
    - name: start {{ AppName }} service
      shell: pm2 startOrRestart ecosystem.config.js --env production
      args:
        chdir: "{{ path }}"
      register: startCqado_out
      notify:
        - restart {{ AppName }}

    - name: Print the {{ AppName }} service startup results
      debug: var=startCqado_out.stdout verbosity=0

    - name: 测试页面是否正常
      shell: netstat -antupl | grep "{{ port }}"
      register: test_out
      ignore_errors: yes

    - name: Print yarn install result
      debug:
        msg: cqaso-web deploy success and port started normally
      when: test_out["rc"] == 0
      ignore_errors: yes

    - name: 新版本归档
      shell: mv {{ AppName }}-{{ version }}-new.tar.gz /tmp/release/{{ AppName }}-{{ version }}-`date +%Y%m%d%H%M%S%`new.tar.gz
      args:
        chdir: /root

  handlers:
    - name: restart {{ AppName }}
      shell: pm2 restart "{{ AppName }}"
